//+__________________________________________________________________+
//| AgetData.mq4                                                     |
//| Copyright 2005,SOAP3000                                          |
//|                                                                  |
//+__________________________________________________________________+
#property copyright "SOAP3000"
#property link "aaa"
#property indicator_chart_window
extern int number_bars=2000;
extern int from_year = 2005;

int start()
{
   int handle;
   int cnt;
   int _year = 1990;
   int _month = 1;
   int _day = 1;
   string strline;
   string name_file;
   name_file = Symbol()+ Period()+ ".prn";
   handle = FileOpen(name_file , FILE_CSV|FILE_WRITE, "\t");
   if(handle<1)
   {
         Print("cannot open file error_",GetLastError());
         return(0);
   }
   else
   {
      for (cnt = number_bars; cnt >= 0; cnt--)
         if (Period() < 1440)
         {
            if (from_year < TimeYear(Time[cnt]))
            {
               strline = DoubleToStr(_year,0);
               if (_month < 10)
                  strline = strline + "0" + DoubleToStr(_month,0);
               else
                  strline = strline + DoubleToStr(_month,0);
               
               if (_day < 10)
                  strline = strline + "0" + DoubleToStr(_day,0);
               else
                  strline = strline + DoubleToStr(_day,0);
               
               strline = strline + ",00:00," + DoubleToStr(Open[cnt],4) + "," + DoubleToStr(High[cnt],4) + "," + DoubleToStr(Low[cnt],4) + "," + DoubleToStr(Close[cnt],4) + "," + DoubleToStr(Volume[cnt],0);
               FileWrite(handle, strline);
               // Start of build virtual date.
               //if (Period() < 1440)
               //{
                  if (_day < 24) {_day++; }
                  else 
                  { 
                     _day = 1;_month++;
                     if (_month > 12)
                     {
                        _month = 1;
                        _year++;
                     }
                  }
               //}
               // End of build virtual date. 
            }
         }
         else
         {
            if (Open[cnt] > 0)
            {
            strline = TimeToStr(Time[cnt],TIME_DATE|TIME_SECONDS);
            strline = StringSubstr(strline,0,4) + StringSubstr(strline,5,2) + StringSubstr(strline,8,2) + "," + StringSubstr(strline,11,5);
            strline = strline + "," + DoubleToStr(Open[cnt],4) + "," + DoubleToStr(High[cnt],4) + "," + DoubleToStr(Low[cnt],4) + "," + DoubleToStr(Close[cnt],4) + "," + DoubleToStr(Volume[cnt],0);
            FileWrite(handle, strline);
            }
         }
           
         FileClose(handle);
         return(0);
   }
}